<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;


include_once AKPATH_COMPONENT.'/controllerform.php' ;

error_reporting(0);

/**
 * Install controller class.
 */
class JoomcloudsControllerInstall extends AKControllerForm
{
	
	public $view_list = 'installs' ;
	public $view_item = 'install' ;
	public $component = 'joomclouds';

	
	/**
     * Constructor.
     *
     * @param   array  $config  An optional associative array of configuration settings.
     *
     * @see     JController
     * @since   11.1
     */
    function __construct() {
		
		$this->allow_url_params = array(
			'return'
		);
		
		$this->redirect_tasks = array(
			'save', 'cancel', 'publish', 'unpublish', 'delete'
		);
		
        parent::__construct();
    }

	/**
	 * install
	 */
	public function install()
	{
		$model = $this->getModel('install');
        if ($model->install()) {
            $cache = JFactory::getCache('mod_menu');
            $cache->clean();
            // TODO: Reset the users acl here as well to kill off any missing bits
        }
 
        $app = JFactory::getApplication();
        $redirect_url = $app->getUserState('com_joomclouds.redirect_url');
        if(empty($redirect_url)) {
            $redirect_url = JRoute::_('index.php?option=com_joomclouds&view=install', false);
        } else
        {
            // wipe out the user state when we're going to redirect
            $app->setUserState('com_joomclouds.redirect_url', '');
            $app->setUserState('com_joomclouds.message', '');
            $app->setUserState('com_joomclouds.extension_message', '');
        }
		
		$result = new JRegistry();
		
		$result->set('AKResult.install_message' ,$model->getState('install.message'));
		$result->set('AKResult.message' ,$model->getState('com_installer.message'));
        $result->set('AKResult.extension_message' 	, $model->getState('com_installer.extension_message'));
        $result->set('AKResult.redirect_url' 		, $model->getState('com_installer.redirect_url'));
		
		jexit($result);
		
        //$this->setRedirect($redirect_url);
	}
	
	/**
     * Function that allows child controller access to model data
     * after the data has been saved.
     *
     * @param   JModel  &$model     The data model object.
     * @param   array   $validData  The validated data.
     *
     * @return  void 
     *
     * @since   11.1
     */
	protected function postSaveHook( &$model, $validData = array())
    {
		$result = $model->postSaveHook($validData) ;
		return $result ;
    }
	
}