<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

include_once dirname(__FILE__).'/../includes/core.php' ;


/**
 * Joomclouds helper.
 */
class JoomcloudsHelper extends AKProxy
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($vName = '')
	{		
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		$app 	= JFactory::getApplication() ;
		
		$menus = array() ;
		
		
		// Add View List Menu Items
		$menus[] = array(
			'title' => JText::_('COM_JOOMCLOUDS_ONLINE_INSTALL_TITLE'),
			'url' => 'index.php?option=com_joomclouds',
			'active' => $vName == 'installs'
		);

	
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_INSTALL'),
			'url' => 'index.php?option=com_installer',
			'active' => $vName == 'install'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_UPDATE'),
			'url' => 'index.php?option=com_installer&view=update',
			'active' => $vName == 'update'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_MANAGE'),
			'url' => 'index.php?option=com_installer&view=manage',
			'active' => $vName == 'manage'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_DISCOVER'),
			'url' => 'index.php?option=com_installer&view=discover',
			'active' => $vName == 'discover'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_DATABASE'),
			'url' => 'index.php?option=com_installer&view=database',
			'active' => $vName == 'database'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_WARNINGS'),
			'url' => 'index.php?option=com_installer&view=warnings',
			'active' => $vName == 'warnings'
		);
		$menus[] = array(
			'title' => JText::_('COM_INSTALLER_SUBMENU_LANGUAGES'),
			'url' => 'index.php?option=com_installer&view=languages',
			'active' => $vName == 'languages'
		);
		
		
		// Trigger for plugin
		$app->triggerEvent( 'onAddSubmenu' , array( 'com_joomclouds.panel' , &$menus)) ;
		
		
		// AddSubmenu
		foreach( $menus as $menu ):
			self::addSubmenuEntry( $menu['title'], $menu['url'], $menu['active'] );
		endforeach;
		
	}
	
	
	
	/*
	 * function addSubmenu
	 * @param $menu
	 */
	
	public static function addSubmenuEntry($title, $url = '#', $active = false)
	{
		if( JVERSION >= 3 ) {
			JHtmlSidebar::addEntry( $title, $url, $active );
		}else{
			JSubMenuHelper::addEntry( $title, $url, $active );
		}
	}
	
	
	
	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions($option = null)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		$assetName = 'com_joomclouds';

		$actions = array(
			'core.admin', 
			'core.manage', 
			'core.create', 
			'core.edit', 
			'core.edit.own', 
			'core.edit.state', 
			'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	
	
	/*
	 * function getVersion
	 * @param 
	 */
	
	public static function getVersion()
	{
		return JVERSION ;
	}
	
}

class JCCHelper extends JoomcloudsHelper {}