<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

include_once AKPATH_COMPONENT.'/modellist.php' ;

/**
 * Methods supporting a list of Joomclouds records.
 */
class JoomcloudsModelInstalls extends AKRequestModelList
{
	/**
	 * @var		string	The prefix to use with controller messages.
	 * @since	1.6
	 */
	protected 	$text_prefix = 'COM_JOOMCLOUDS';
	
	public 		$component = 'joomclouds' ;
	public 		$item_name = 'install' ;
	public 		$list_name = 'installs' ;
	
	public      $request_item = 'collection';
    public      $request_list = 'collections';
	
	public 		$default_method = 'getItems';
	
    /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
    public function __construct($config = array())
    {
		
		// Set query tables
		// ========================================================================
		$config['tables'] = array(
			'a' => '#__joomclouds_installs',
			'b' => '#__categories',
			'c' => '#__users',
			'd' => '#__viewlevels',
			'e' => '#__languages'
		);
		
		
		
		// Set filter fields
		// ========================================================================
        if (empty($config['filter_fields'])) {
            $config['filter_fields'] = array(
                'filter_order_Dir', 'filter_order', '*'
            );
			
            //$config['filter_fields'] = JoomcloudsHelper::_('db.mergeFilterFields', $config['filter_fields'] , $config['tables'] );
        }
		
		
		
		// Other settings
		// ========================================================================
		$config['fulltext_search'] 	= true ;
		
		$config['core_sidebar'] 	= false ;
		
		
		$this->config = $config ;
		
        parent::__construct($config);
		
    }
	
	
	
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = null, $prefix = null, $config = array())
	{
		return new JObject();//parent::getTable( $type , $prefix , $config );
	}

	
	
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Set First order field
		$this->setState('list.orderingPrefix', array(/*'a.catid'*/)) ;
		
		parent::populateState('title', 'asc');
	}
	
	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param	string		$id	A prefix for the store id.
	 * @return	string		A store id.
	 * @since	1.6
	 */
	protected function getStoreId($id = '')
	{
		return parent::getStoreId($id);
	}
	
	
	/**
	 * Method to get list page filter form.
	 *
	 * @return	object		JForm object.
	 * @since	2.5
	 */
	
	public function getFilter()
	{
		$filter = parent::getFilter();
		
		return $filter ;
	}
	
	/*
	 * function getExtensions
	 * @param 
	 */
	
	public function getExtensions()
	{
		$db = JFactory::getDbo();
		$q = $db->getQuery(true) ;
		
		$q->select("*")
			->from("#__extensions")
			;
		
		$db->setQuery($q);
		$exts = $db->loadObjectList();
		
		$results = array();
		
		foreach( $exts as $ext ):
			$folder = $ext->folder ? '.'.$ext->folder : '' ;
			$results[ $ext->element.$folder ] = 1;
		endforeach;
		
		return $results ;
	}
	
	/**
	 * function getAPIResult
	 */
	public function getAPIResult()
	{
		
		$filter = $this->getState('filter', array());
		
		if( !empty($filter['environments']) ) {
			$environments = array();
			
			foreach( $filter['environments'] as $environment ):
				if(!$environment) continue;
				$environments[$environment] = 1 ;
			endforeach;
			
			$filter['environment'] = $environments;
		}
		
		$this->setState('filter', $filter);
		
		$result = parent::getAPIResult();
		
		return $result ;
	}
	
	/**
	 * Set search condition to support multiple search inputs.
	 * 
	 * @param   array			$search	Search fields and values.
	 * @param   JDatabaseQuery	$q		The query object.
	 * @param   array			$ignore	An array for ignore fields.
	 *
	 * @return  JDatabaseQuery    
	 */
	public function searchCondition($search, $q = null, $ignore = array())
	{
		// Set ignore fields, and you can set yourself search later.
		if(!$ignore) {
			$ignore = array(
				// 'a.title',
				// 'b.title'
			);
		}
		
		$q = parent::searchCondition($search, $q, $ignore);
		
		// Do some another filter here
		
		
		
		return $q ;
	}
	
	/**
	 * Set query filter.
	 * 
	 * @param   array			$filter	Filter fields and values.
	 * @param   JDatabaseQuery	$q		The query object.
	 * @param   array			$ignore	An array for ignore fields.
	 *
	 * @return  type    
	 */
	public function filterCondition($filter, $q = null, $ignore = array())
	{
		// Set ignore fields, and you can set yourself filter later.
		if(!$ignore) {
			$ignore = array(
				// 'a.published',
				// 'b.id'
			);
		}
		
		$q = parent::filterCondition($filter, $q, $ignore);
		
		// Do some another filter here
		
		
		
		return $q ;
	}
}
