<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;


// Init some API objects
// ================================================================================
$app 	= JFactory::getApplication() ;
$date 	= JFactory::getDate( 'now' , JFactory::getConfig()->get('offset') ) ;
$doc 	= JFactory::getDocument();
$uri 	= JFactory::getURI() ;
$user	= JFactory::getUser();
$userId	= $user->get('id');



// List Control
// ================================================================================
$nested		= $this->state->get('items.nested') ;
$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$orderCol 	= $this->state->get('list.orderCol', 'a.ordering') ;
$canOrder	= $user->authorise('core.edit.state', 'com_joomclouds');
$saveOrder	= $listOrder == $orderCol || ($listOrder == 'a.lft' && $listDirn == 'asc');
$trashed	= $this->state->get('filter.published') == -2 ? true : false;
$show_root	= JRequest::getVar('show_root') ;


// For Joomla!3.0
// ================================================================================
if( JVERSION >= 3 ) {
	if ($saveOrder)
	{
		$method = $nested ? 'saveOrderNestedAjax' : 'saveOrderAjax' ;
		$saveOrderingUrl = 'index.php?option=com_joomclouds&task=installs.'.$method.'&tmpl=component';
		JHtml::_('sortablelist.sortable', 'itemList', 'adminForm', strtolower($listDirn), $saveOrderingUrl, false, $nested);
	}
}
?>

<!-- List Table -->
<table class="table table-striped adminlist" id="itemList">
	
	<!--PAGINATION-->
	<tfoot>
		<tr>
			<td colspan="15">
				<div class="pull-left">
					<?php echo $this->pagination->getListFooter(); ?>
				</div>
				
				<?php if( JVERSION >= 3 ): ?>
				<!-- Limit Box -->
				<div class="btn-group pull-right hidden-phone">
					<label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC');?></label>
					<?php echo $this->pagination->getLimitBox(); ?>
				</div>
				<?php endif; ?>
			</td>
		</tr>
	</tfoot>
	
	
	<tbody>
	<?php foreach ($this->items as $i => $item) :
		
		$item 		= new JObject($item);
		?>
		<tr class="row<?php echo $i % 2; ?>">
		
		
			<!--<td class="center">
				<?php echo JHtml::_('grid.id', $i, $item->id); ?>
			</td>-->
			
			<td class="n/owrap has-context">
                <?php
                    $collection_ids = $item->get('collections') ;
					$collection_ids = json_encode($collection_ids);
                ?>
				<!-- BUTTON -->
				<input id="install-button" type="button" class="button btn btn-primary btn-small <?php //echo $button_color; ?> fltrt pull-right" value="<?php echo JText::_('COM_JOOMCLOUDS_INSTALL'); ?>"
					onclick='Joomclouds.installBundle( "<?php echo $item->id; ?>" , <?php echo $collection_ids; ?> , this)' />
				
				<!-- Title -->
				<div class="bundle-heading">
					<h2 class="fltlft pull-left">
                        <?php echo $item->get('title'); ?>
                        (<?php echo count($item->get('collections')); ?>)
					</h2>
					
					<div class="clr clearfix"></div>
				</div>
				
				<div class="bundle-information">
					<?php
                        echo JCCHelper::_('tablelist.buildLabels', $item->get('collections'), $this->extensions);
                    ?>
				</div>
				
				
				
			</td>
			
		

		</tr>
		<?php endforeach; ?>
	</tbody>
</table>