<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.framework', true);

if( JVERSION < 3 ) {
    AKHelper::_('include.addCSS', 'bootstrap3/bootstrap.css');
}

$isLogin = $this->isLogin ;

$params = JComponentHelper::getParams('com_joomclouds') ;
?>

<script>
    window.addEvent('domready', function(){
        $('loginForm').addEvent('keydown', function(event){
            if ( event.key == 'enter') {
                event.preventDefault();
                jQuery('#loginModal').modal('hide');
                this.submit();
            }
        });
    });
</script>

<div id="loginModal" class="<?php echo JVERSION >= 3 ? 'modal hide fade joomla3' : 'joomla25 well' ; ?> login-modal-container" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <form action="<?php echo JFactory::getURI()->toString(); ?>" method="post" name="loginForm" id="loginForm" enctype="multipart/form-data">
        
        <!--header-->
        <div class="modal-header">
            <?php if( JVERSION >= 3 ): ?>
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <?php endif; ?>
            <h3><span class="glyphicon glyphicon-user icon-user"></span> <?php echo JText::_('COM_JOOMCLOUDS_LOGIN_MODAL_HEADER'); ?></h3>
        </div>
        
        <?php if( !$isLogin ): ?>
            <!--Body-->
            <div class="modal-body form-horizontal">
                
                
                <div class="control-group form-group">
                    <label class="control-label col-lg-2" for="inputEmail"><?php echo JText::_('JGLOBAL_USERNAME'); ?></label>
                    <div class="controls col-lg-8">
                        <input type="text" id="inputEmail" class="form-control" name="login[username]" value="<?php echo $params->get('jcserver.username'); ?>" placeholder="<?php echo JText::_('JGLOBAL_USERNAME'); ?>">
                    </div>
                </div>
                <div class="control-group form-group">
                    <label class="control-label  col-lg-2" for="inputPassword"><?php echo JText::_('JGLOBAL_PASSWORD'); ?></label>
                    <div class="controls col-lg-8">
                        <input type="password" id="inputPassword" class="form-control col-lg-10" name="login[password]" value="<?php echo $params->get('jcserver.password'); ?>" placeholder="<?php echo JText::_('JGLOBAL_PASSWORD'); ?>">
                    </div>
                </div>
                
                <ul class="text-right nav">
                    <li>
                        <a href="http://www.joomclouds.com/register" target="_blank">
                            <?php echo JText::_('COM_JOOMCLOUDS_LOGIN_SIGN_UP'); ?>
                        </a>    
                    </li>
                </ul>
            </div>
            
            <!--Footer-->
            <div class="modal-footer text-right">
                <input type="hidden" name="task" value="user.login" />
                <input type="hidden" name="return" value="<?php echo AKHelper::_('uri.base64', 'encode', JFactory::getURI()->toString() ); ?>" />
                
                
                <button href="#" class="btn btn-default" data-dismiss="modal" aria-hidden="true" onclick="if(window.parent) window.parent.SqueezeBox.close();"><?php echo JText::_('COM_JOOMCLOUDS_LOGIN_CLOSE'); ?></button>
                <button class="aa btn btn-primary blue"><?php echo JText::_('COM_JOOMCLOUDS_LOGIN_BUTTON'); ?></button>
            </div>
            
        <?php else: ?>
            
            <!--Body-->
            <div class="modal-body">
                
                <div id="" class="loggedin-information">
                    <?php echo JText::sprintf('COM_JOOMCLOUDS_USER_HELLO', $params->get('jcserver.username')); ?>
                </div>
                
            </div>
            
            <!--Footer-->
            <div class="modal-footer text-right">
                <input type="hidden" name="task" value="user.logout" />
                <input type="hidden" name="return" value="<?php echo AKHelper::_('uri.base64', 'encode', JFactory::getURI()->toString() ); ?>" />
                
                
                <button href="#" class="login-cancel-button btn btn-default" data-dismiss="modal" aria-hidden="true" onclick="if(window.parent) window.parent.SqueezeBox.close();return false;"><?php echo JText::_('COM_JOOMCLOUDS_LOGIN_CLOSE'); ?></button>
                <button class="login-submit-button btn btn-primary blue"><?php echo JText::_('COM_JOOMCLOUDS_LOGOUT_BUTTON'); ?></button>
            </div>
        
        <?php endif; ?>
        
    </form>
</div>  
