<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_joomclouds
 *
 * @copyright   Copyright (C) 2012 Asikart. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Generated by AKHelper - http://asikart.com
 */

// no direct access
defined('_JEXEC') or die;

include_once AKPATH_COMPONENT.'/viewlist.php' ;

/**
 * View class for a list of Joomclouds.
 */
class JoomcloudsViewInstalls extends AKViewList
{
	/**
	 * @var		string	The prefix to use with controller messages.
	 * @since	1.6
	 */
	protected 	$text_prefix = 'COM_JOOMCLOUDS';
	protected 	$items;
	protected 	$pagination;
	protected 	$state;
	
	
	public		$option 	= 'com_joomclouds' ;
	public		$list_name 	= 'installs' ;
	public		$item_name 	= 'install' ;
	public	 	$no_trash 	= false ;
	public		$sort_fields ;

	public 		$isLogin 	= true ;
	
	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$app = JFactory::getApplication() ;
		
		$method = 'prepare'.ucfirst($app->input->get('layout', 'default'));
		$this->$method() ;
		
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->extensions	= $this->get('Extensions');
		$this->filter		= $this->get('Filter');
		
		
		$service 		= AKHelper::_('api.getSDK');
		$this->isLogin  = $service->isLogin ;
		
		
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			
			$this->isNeedLogin();
			
			if(!$this->isLogin){
				JError::raiseNotice(500, $errors[0]);
			}else{
				JError::raiseWarning(500, $errors[0]);
			}
			return false;
		}
		
		$method = 'post'.ucfirst($app->input->get('layout', 'default'));
		$this->$method() ;
		
		parent::displayWithPanel($tpl);
	}

	/**
	 * function prepareDefault
	 */
	public function prepareDefault()
	{
	}
	
	/**
	 * function postDefault
	 */
	public function postDefault()
	{
		// Sort Fields
		$ordering_key = $this->state->get('list.orderCol', 'a.ordering') ;
		
		$this->sort_fields = array(
			'title' 			=> JText::_('JGLOBAL_SORT_BY') . '-' . JText::_('JGLOBAL_TITLE'),
			'category' 			=> JText::_('JCATEGORY'),
			'folder'			=> JText::_('COM_JOOMCLOUDS_PLUGIN_GROUP'),
			'client'			=> JText::_('COM_INSTALLER_TYPE_CLIENT'),
			'created' 			=> JText::_('JDATE')
		);
		
	}
	
	/**
	 * function prepareBundles
	 */
	public function prepareBundles()
	{
		$model = $this->getModel();
		
		$model->request_item = 'bundle' ;
		$model->request_list = 'bundles' ;
	}
	
	/**
	 * function postBundles
	 */
	public function postBundles()
	{
		// Sort Fields
		$ordering_key = $this->state->get('list.orderCol', 'a.ordering') ;
		
		$this->sort_fields = array(
			'title' 			=> JText::_('JGLOBAL_SORT_BY') . '-' . JText::_('JGLOBAL_TITLE'),
			'created' 			=> JText::_('JDATE')
		);
	}
	
	/**
	 * function isNeedLogin
	 */
	public function isNeedLogin()
	{
		$service = AKHelper::_('api.getSDK');

		if( $service->isLogin ) return ;
		
		$input = JFactory::getApplication()->input ;
		$this->setLayout('needlogin');
		
		parent::displayWithPanel(null);
	}
	
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		$app      = JFactory::getApplication() ;
        $state    = $this->get('State');
        $canDo    = AKHelper::getActions($this->option);
        $user     = JFactory::getUser() ;
        $filter_state     = $this->state->get('filter') ;
		
		$input 	= $app->input ;
		
		// Set title.
		AKToolBarHelper::title( JText::_('COM_JOOMCLOUDS_SEARCHS_TITLE') . ': ' . JText::_('COM_JOOMCLOUDS_'.$input->getVar('layout', 'collections')) , 'puzzle');
		
		// Login Modal
		AKHelper::_('ui.modal', 'loginModal') ;
        $bar	= JToolbar::getInstance('toolbar');
        $title  = JVERSION >= 3 ? '' : '<span class="glyphicon glyphicon-user icon-user"></span> ' ;
		$title  .= $this->isLogin ? JText::_('COM_JOOMCLOUDS_LOGOUT') : JText::_('COM_JOOMCLOUDS_LOGIN');
        
        $option = array(
            'class' => 'nav-login-button' ,
            'icon'	=> 'icon-user'
        );
		$doc = JFactory::getDocument();
		$doc->addStyleDeclaration('.icon-32-adduser {background-image: url(templates/bluestork/images/toolbar/icon-32-adduser.png);	}');
		
		
        
        $this->login_button = $dhtml	= AKHelper::_('ui.modalLink', $title, 'loginModal', $option) ;
        //$bar->appendButton('Custom', $dhtml, 'adduser');   
		
		if ($canDo->get('core.admin') && $app->isAdmin() ) {
            AKToolBarHelper::preferences($this->option);
        }

	}
	
	
	/**
	 * Returns an array of fields the table can be sorted by
	 *
	 * @return  array  Array containing the field name to sort by as the key and display text as value
	 *
	 * @since   3.0
	 */
	protected function getSortFields()
	{
		return $this->sort_fields ;
	}
	
	
}
